﻿using DevExpress.XtraEditors;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Xceed.Words.NET;

namespace lecturerHelper
{
    public partial class Form_main : DevExpress.XtraEditors.XtraForm
    {
        public class QuestionPackData
        {
            [DisplayName("Номер билета")]
            public int QuestionPackNumber { get; set; }
            [DisplayName("Первый вопрос")]
            public string FirstQuestion { get; set; }
            [DisplayName("Второй вопрос")]
            public string SecondQuestion { get; set; }
            [DisplayName("Третий вопрос")]
            public string ThirdQuestion { get; set; }
            [DisplayName("Четвертый вопрос")]
            public string FourthQuestion { get; set; }
            [DisplayName("Пятый вопрос")]
            public string FifthQuestion { get; set; }

            public QuestionPackData()
            {
                this.QuestionPackNumber = 0;
                this.FirstQuestion = string.Empty;
                this.SecondQuestion = string.Empty;
                this.ThirdQuestion = string.Empty;
                this.FourthQuestion = string.Empty;
                this.FifthQuestion = string.Empty;
            }
        }

        string ClipboardData
        {
            get
            {
                IDataObject iData = Clipboard.GetDataObject();
                if (iData == null) return "";

                if (iData.GetDataPresent(DataFormats.Text))
                    return (string)iData.GetData(DataFormats.Text);
                return "";
            }
            set { Clipboard.SetDataObject(value); }
        }

        public Form_main()
        {
            InitializeComponent();

            BindingList<QuestionPackData> data = new BindingList<QuestionPackData>();
            data.AllowNew = true;
            data.AllowRemove = true;
            data.AllowEdit = true;
            
            this.gridControl1.DataSource = data;
            this.gridControl1.RefreshDataSource();

            for (int i = 0; i < this.gridView1.Columns.Count; i++)
            {
                this.gridView1.Columns[i].BestFit();
            }
        }

        private void simpleButton1_Click(object sender, EventArgs e)
        {
            if (this.textEdit1.Text.Trim() == string.Empty)
            {

                XtraMessageBox.Show("Введите название дисциплины",
                                    "Ошибка",
                                    MessageBoxButtons.OK,
                                    MessageBoxIcon.Error);
                return;

            }

            string partName = this.textEdit1.Text;// "Разработка САПР";
            int number = 1;

            DocX out_doc = DocX.Create("exam_output.docx", DocumentTypes.Document);
            out_doc.MarginTop = 40;
            out_doc.MarginBottom = 40;
            out_doc.MarginLeft = 40;
            out_doc.MarginRight = 40;

            if (this.gridControl1.DataSource is BindingList<QuestionPackData>)
            {
                BindingList<QuestionPackData> ds = (BindingList<QuestionPackData>)this.gridControl1.DataSource;

                int nPageCount = 0;
                for (int i = 0; i < ds.Count; i++)
                {
                    nPageCount++;
                    Table nTab = out_doc.AddTable(2, 3);
                    nTab.SetWidths(new float[] { 150f, 300f, 90f });
                    //nTab.AutoFit = AutoFit.Contents;
                    nTab.Rows[0].Cells[0].Paragraphs[0].Append("Федеральное государственное бюджетное образовательное учреждение высшего образования\n«Московский авиационный институт (национальный исследовательский университет)»").FontSize(10).Font("Times New Roman").Alignment = Alignment.center;

                    nTab.Rows[0].Cells[1].Paragraphs[0].Append("Кафедра «316»").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].InsertParagraph("").Font("Times New Roman").FontSize(3).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].InsertParagraph("Э К З А М Е Н А Ц И О Н Ы Й   Б И Л Е Т").Font("Times New Roman").FontSize(12).Bold().Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].InsertParagraph("").Font("Times New Roman").FontSize(5).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].InsertParagraph("№ ").Font("Times New Roman").FontSize(12).Bold().Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].Paragraphs[4].Append("__" + number + "__").Font("Times New Roman").FontSize(12).Bold().UnderlineStyle(UnderlineStyle.singleLine);
                    nTab.Rows[0].Cells[1].InsertParagraph("").Font("Times New Roman").FontSize(5).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].InsertParagraph("По дисциплине «" + partName + "»").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[1].VerticalAlignment = VerticalAlignment.Center;

                    nTab.Rows[0].Cells[2].Paragraphs[0].Append("«Утверждаю»").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].InsertParagraph("Зав. Кафедрой").Font("Times New Roman").FontSize(12).Italic().Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].InsertParagraph("").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].InsertParagraph("").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].InsertParagraph("________________").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].InsertParagraph("Хорошко Л.Л.").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].InsertParagraph("«__» _____ 20__ г.").Font("Times New Roman").FontSize(12).Alignment = Alignment.center;
                    nTab.Rows[0].Cells[2].VerticalAlignment = VerticalAlignment.Center;


                    nTab.Rows[1].MergeCells(0, 2);
                    nTab.Rows[1].Cells[0].InsertParagraph("").Font("Times New Roman").FontSize(12);
                    if (ds[i].FirstQuestion != string.Empty)
                    {
                        nTab.Rows[1].Cells[0].InsertParagraph("    1. " + ds[i].FirstQuestion).Font("Times New Roman").FontSize((int)this.spinEdit1.Value);
                    }
                    if (ds[i].SecondQuestion != string.Empty)
                    {
                        nTab.Rows[1].Cells[0].InsertParagraph("    2. " + ds[i].SecondQuestion).Font("Times New Roman").FontSize((int)this.spinEdit1.Value);
                    }
                    if (ds[i].ThirdQuestion != string.Empty)
                    {
                        nTab.Rows[1].Cells[0].InsertParagraph("    3. " + ds[i].ThirdQuestion).Font("Times New Roman").FontSize((int)this.spinEdit1.Value);
                    }
                    if (ds[i].FourthQuestion != string.Empty)
                    {
                        nTab.Rows[1].Cells[0].InsertParagraph("    4. " + ds[i].FourthQuestion).Font("Times New Roman").FontSize((int)this.spinEdit1.Value);
                    }
                    if (ds[i].FifthQuestion != string.Empty)
                    {
                        nTab.Rows[1].Cells[0].InsertParagraph("    5. " + ds[i].FifthQuestion).Font("Times New Roman").FontSize((int)this.spinEdit1.Value);
                    }

                    nTab.Rows[1].Height = 140;

                    out_doc.InsertTable(nTab);
                    number++;
                    if (nPageCount > 2)
                    {
                        if (i < ds.Count - 1)
                        {
                            out_doc.InsertParagraph().InsertPageBreakAfterSelf();
                            nPageCount = 0;
                        }
                    }
                }
            }

            out_doc.Save();


            DialogResult res = XtraMessageBox.Show("Открыть файл?",
                                    "Вопрос",
                                    MessageBoxButtons.YesNoCancel,
                                    MessageBoxIcon.Question,
                                    MessageBoxDefaultButton.Button2);

            if (res == DialogResult.Yes)
            {
                System.Diagnostics.Process.Start("exam_output.docx");
            }
        }

        private void simpleButton2_Click(object sender, EventArgs e)
        {
            if (this.gridControl1.DataSource is BindingList<QuestionPackData>)
            {
                BindingList<QuestionPackData> ds = (BindingList<QuestionPackData>)this.gridControl1.DataSource;

                string[] data = ClipboardData.Split('\n');
                if (data.Length < 1) return;
                foreach (string row in data)
                {
                    string[] rowData = row.Split(new char[] { '\r', '\x09' });
                    QuestionPackData newData = new QuestionPackData();
                    for (int i = 0; i < rowData.Length; i++)
                    {
                        if (i == 0) { int i_val = 0; int.TryParse(rowData[0], out i_val); newData.QuestionPackNumber = i_val; }
                        if (i == 1) { newData.FirstQuestion = rowData[1]; }
                        if (i == 2) { newData.SecondQuestion = rowData[2]; }
                        if (i == 3) { newData.ThirdQuestion = rowData[3]; }
                        if (i == 4) { newData.FourthQuestion = rowData[4]; }
                        if (i == 5) { newData.FifthQuestion = rowData[5]; }
                    }
                    if (rowData.Length > 1)
                    {
                        ds.Add(newData);
                    }
                }

                this.gridControl1.RefreshDataSource();

                for (int i = 0; i < this.gridView1.Columns.Count; i++)
                {
                    this.gridView1.Columns[i].BestFit();
                }
            }
        }
    }
}
